"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isReSubComponent = exports.createRule = void 0;
var utils_1 = require("@typescript-eslint/utils");
exports.createRule = utils_1.ESLintUtils.RuleCreator(function () { return ''; });
var isReSubComponent = function (scope) {
    var currentScope = scope;
    while (scope && scope.type !== 'class') {
        currentScope = scope.upper;
    }
    var node = currentScope && currentScope.block;
    if (!node || node.type !== utils_1.AST_NODE_TYPES.ClassDeclaration) {
        return false;
    }
    var superClass = node.superClass;
    if (!superClass || superClass.type !== utils_1.AST_NODE_TYPES.Identifier) {
        return false;
    }
    return superClass.name === 'ComponentBase';
};
exports.isReSubComponent = isReSubComponent;
